
ChiliProject - Feature # 574: Sub-project repository commits not displayed on parent project issues

Status: Closed Priority: Normal
Author: Daniele Segato Category: Text formatting
Created: 2011-08-12 Assignee: Felix Schäfer
Updated: 2011-09-05 Due date:
Remote issue URL:
Affected version: 2.1.1
Description: It's common the need to link a commit in a suproject from a parent project issue.

commit:12abc34 is not resolved if the commit is present in a sub-project.

This has ben solved in redmine here:
http://www.redmine.org/issues/4674

I'd really like to see this feature in the next 2.2 release

History
2011-08-21 09:55 pm - Felix Schäfer
- Assignee set to Felix Schäfer

- Status changed from Open to Needs more information

The link to Redmine you have posted is for the other way round, i.e. you have some @#123@ in your commit message and ChiliProject/Redmine will 
link that commit to issue 123. That code is from before the fork and is identical in Redmine and ChiliProject.

What you want is the "ChiliProject/Redmine markup" @commit:@ links to potentially point to commits other than the ones in the repository of the 
project. Those are currently restricted to the project's repository for a good reason: does @r6@ point to revision 6 in your own repository? That of the 
child project? Or one deeper? Or maybe of the parent? I agree this doesn't make as much sense with hashed commit ids which are (nearly) unique, but 
I'm not sure that would be the case for all SCMs. I'll try to research the matter a little more.

2011-08-22 07:23 am - Daniele Segato
yes I want the markup @commit:@ in the issue notes and description to be able to link commit of sub-projects repository (cross project would be 
better)

Actually two commit may have the same hash but the probability of that is so low that it's a waste of time to bother about it...

why don't add some new syntax to link a commit in another repo?
maybe extcommit:<prj-id>:<hash>

but I think that you would need a way to let the user choose from a list of project (you can't assume the user know/remember the project id)

2011-08-22 10:36 am - Felix Schäfer
- Category changed from Issue tracking to Text formatting

Daniele Segato wrote:
> Actually two commit may have the same hash but the probability of that is so low that it's a waste of time to bother about itâ€¦

That's what I meant by "nearly" unique, and I know this is the case for git, I don't know about darcs/hg thoughâ€¦

> why don't add some new syntax to link a commit in another repo?

2020-10-25 1/2



> maybe extcommit:<prj-id>:<hash>

We're currently trying to not extend the syntax as we're not very satisfied with it, though having one common scheme to resources in other projects 
would be nice. Anyhow, as revisions are not unique, we can't let @r6@ point to the revision 6 of another project without extending the syntax, I'll 
ponder if we can remove this limitation for commits though.

2011-09-04 09:16 pm - Holger Just
- Status changed from Needs more information to Closed

You can always prefix the commit reference with the project identifier. So you can say @subproject:commit:12abc34@ and it should display the correct 
link. The same works as well with subversion revisions like @subproject:r6@.

I think we will never try to guess where the commit hash (or any other object identifier) should point to as this would lead to unpredictable behavior 
which would confuse people even more.

2011-09-05 07:07 am - Daniele Segato
@Holger I found no documentation about this syntax "<subproject>:commit:<hash>".

That's perfect to me... but you should add that to the documentation.
